﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;

namespace úloha_1
{
    public partial class Form1 : Form
    {
        BackgroundWorker worker;
        private List<Image> Images = new List<Image>(); //Database obrázků
        private List<int> lib = new List<int>(); //přiřazení souřadnic k obrázkům
        private bool exist(int _Z, int _Y, int _X)
        {
            try
            {
                Image i = Images[lib.IndexOf(_X + _Y * 100 + _Z * 10000)];
            }
            catch
            {
                return false;
            }
            return true;
        } //
        private Image gt(int _Z, int _Y, int _X)
        {
            int K =_X + _Y * 100 + _Z * 10000;
            if (K > -1)
            {
                int I = lib.FindIndex(mc => mc.Equals(K));
                return Images[I];
            }
            return new Bitmap(256, 256);
        } //získání obrázku z database
        private void st(int _Z, int _Y, int _X, Image img)
        {
            int K = _X + _Y * 100 + _Z * 10000;
            if (K > -1)
            {
                Images.Add(img);
                lib.Add(K);
            }
        } //nahrání obrázku do database
        protected int x;
        private int X
        {
            get
            {
                return x;
            }
            set
            {
                x = value;
                tB_X.Text = value.ToString();
            }
        }
        protected int y;
        private int Y
        {
            get
            {
                return y;
            }
            set
            {
                y = value;
                tB_Y.Text = value.ToString();
            }
        }
        protected int z;
        private int Z
        {
            get
            {
                return z;
            }
            set
            {
                if (value > -1 && value < 10)
                {
                    z = value;

                    tB_Z.Text = value.ToString();
                }
            }
        }
        public Form1()

        {
            worker = new BackgroundWorker();
            worker.ProgressChanged += worker_ProgressChanged;
            InitializeComponent();
            AktualizujMapu();
        }
        private void worker_ProgressChanged(object sender, System.ComponentModel.ProgressChangedEventArgs e)
        {
            MessageBox.Show("");
        }
        private void WorkerDoWork(int _z,int  _y,int  _x) 
        {
            WebRequest requestPic = WebRequest.Create("http://192.168.2.76:" + textBox1.Text + "/" + _z + "/" + _x + "/" + _y + ".jpg");
            try
            {
                WebResponse responsePic = requestPic.GetResponse();
                Image webImage = Image.FromStream(responsePic.GetResponseStream());
                Bitmap b = new Bitmap(webImage);
                Report r = new Report();

                st(_z, _y, _x, b);
               
            }
            catch (Exception e1) { }
        }
        private Bitmap GetMap(int _z,int _x, int _y) // Získání mapy
        {
            if (exist(_z, _y, _x)) //Pokud je mapa uz stahla
            {
                return new Bitmap(gt(_z, _y, _x)); //tak si ji nahraju z database
            }
            WebRequest requestPic = WebRequest.Create("http://192.168.2.76:" + textBox1.Text + "/" + _z + "/" + _x + "/" + _y + ".jpg");
            try
            {
                WebResponse responsePic = requestPic.GetResponse();
                Image webImage = Image.FromStream(responsePic.GetResponseStream());
                st(_z, _y, _x, new Bitmap(webImage));
                return new Bitmap(webImage);
            }
            catch (Exception e1) { Bitmap b = new Bitmap(256, 256); }
            return new Bitmap(256, 256); 
        }

        private void AktualizujMapu()
        {
            pb_00.Image = new Bitmap(256, 256); 
            pb_01.Image = new Bitmap(256, 256);
            pb_02.Image = new Bitmap(256, 256);
            pb_04.Image = new Bitmap(256, 256);
            pb_05.Image = new Bitmap(256, 256);
            pb_06.Image = new Bitmap(256, 256);
            pb_07.Image = new Bitmap(256, 256);
            pb_08.Image = new Bitmap(256, 256);
            try
            {
                AktualizujSouradnice();
                pb_00.Image = GetMap(Z, X, Y - 1);
                pb_01.Image = GetMap(Z, X + 1, Y - 1);
                pb_02.Image = GetMap(Z, X + 2, Y - 1);
          
                pb_03.Image = GetMap(Z, X, Y);
                pb_04.Image = GetMap(Z, X + 1, Y);
                pb_05.Image = GetMap(Z, X + 2, Y);
                pb_06.Image = GetMap(Z, X, Y + 1);
                pb_07.Image = GetMap(Z, X + 1, Y + 1);
                pb_08.Image = GetMap(Z, X + 2, Y + 1);
            }
            catch (Exception e1)
            {
                //MessageBox.Show(e1.Message);
            }
            for (int x = -2; x > 6; x++ )
            {
                for (int y = -2; y > 6; y++)
                {
                    GetMap(Z, X + x, Y + y);
                }
            }
        } //vykreslování map

        private void AktualizujSouradnice() //získání souřadnic z textboxu
        {
            try
            {
                Z = int.Parse(tB_Z.Text);
                X = int.Parse(tB_X.Text);
                Y = int.Parse(tB_Y.Text);
            }
            catch { }
        }

        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {
            MessageBox.Show(e.KeyChar.ToString());
        }

        private void tB_Z_TextChanged(object sender, EventArgs e)
        {
            AktualizujSouradnice();
            AktualizujMapu();
        }
        private void tB_X_TextChanged(object sender, EventArgs e)
        {
            AktualizujSouradnice();
            AktualizujMapu();
        }
        private void tB_Y_TextChanged(object sender, EventArgs e)
        {
            AktualizujSouradnice();
            AktualizujMapu();
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            
        }

        private void button1_KeyPress(object sender, KeyPressEventArgs e) //interaktivní ovládání klávesnicí
        {
            int _t;
            switch (e.KeyChar.ToString())
            {
                
                case "+":
                    Z++;
                    
                    _t = Convert.ToInt32(Math.Pow(2, Z));
                    X = X + (_t / 2);
                    _t = Convert.ToInt32(Math.Pow(2, Z));
                    Y = Y + (_t / 2);
                    break;
                case "-":
                    Z--;
                    
                    _t = Convert.ToInt32(Math.Pow(2, Z));
                    X = X - _t ;
                    _t = Convert.ToInt32(Math.Pow(2, Z));
                    Y = Y - _t;
                    break;
                case "2":
                    Y++;
                    break;
                case "4":
                    X--;
                    break;
                case "6":
                    X++;
                    break;
                case "8":
                    Y--;
                    break;
            }   
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            AktualizujMapu();
        }
        
    }
    public class Report
    {
        public int x;
        public int y;
        public int z;
        public Image img;
    }
}
